#include "CpuInput.h"

#include "SDL.h"
#include "SDL_gfxPrimitives.h"

CpuInput :: CpuInput () : InputObj ()
{
  counter = 0;
  attStruct = NULL;
  damageToPlayer = 1;
}

void CpuInput :: setStats (Uint16 dmg)
{
  damageToPlayer = dmg;
}


void CpuInput :: processInput (const SDL_Event & mainEvent)
{
  //this was supposed to be where the AI does its mojo...but that's too complicated.
}

void CpuInput :: getNextMove ()
{
  //insert AI here...for now, a dumb AI
  //This should set up an SDL_Event for later export in processInput.
  counter ++;

  SDL_Event attMade;

  //counter should be redone later.
  if (counter > 5)
    {
      attStruct = new SDL_Rect ();
      attStruct -> w = 0; //right attacks, hits left
      attStruct -> h = damageToPlayer; //how much damage is inflicted?

      attMade.type = SDL_USEREVENT;
      attMade.user.code = 0;
      attMade.user.data1 = (void *) attStruct;
      attMade.user.data2 = 0;
      SDL_PushEvent(&attMade);

      counter = 0;
      moveDone = true;
    }
}

bool  CpuInput :: getMoveDone ()
{
  bool ans = moveDone;

  if (moveDone)
    moveDone = false;

  return ans;
}

void CpuInput :: render (SDL_Surface * dest, int accuracy)
{
  filledCircleRGBA(dest, posX, posY, accuracy, 128, 128, 128, 128);
}

void CpuInput :: addDamage (Uint16 d)
{
  if (d + damageToPlayer > 32768)
    damageToPlayer = 32768;
  else
    damageToPlayer += d;
}

CpuInput :: ~ CpuInput ()
{
}
