#ifndef CPUINPUT_H
#define CPUINPUT_H

#include "SDL.h"
#include "SDL_gfxPrimitives.h"

#include "InputObj.h"

class CpuInput : public InputObj {
 public:
  CpuInput ();

  //add line pattern to this, as well.
  void setStats (Uint16);
  void addDamage (Uint16);

  virtual void processInput (const SDL_Event & mainEvent);
  virtual void render (SDL_Surface * dest, int);

  virtual void getNextMove ();
  bool getMoveDone ();

  ~CpuInput ();

 protected:
  Sint8 counter;
  Uint16 damageToPlayer;
  bool moveDone;
  SDL_Rect * attStruct;
};

#endif
